#############################################################################
##  CUBE        http://www.scalasca.org/                                   ##
#############################################################################
##  Copyright (c) 2015-2020                                                ##
##  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          ##
##                                                                         ##
##  This software may be modified and distributed under the terms of       ##
##  a BSD-style license.  See the COPYING file in the package base         ##
##  directory for details.                                                 ##
#############################################################################
CUBEGUI_CONFIG =   cubegui-config
CUBELIB_CONFIG =   cubelib-config
OTF2_CONFIG    =   otf2-config

INCLUDEPATH += \
                  ../src/syntax \
                  ../src/gui \
                  ../src/tracelib
				  
unix:INCLUDEPATH    += $$system($$CUBEGUI_CONFIG --include) \ 
					   $$system($$CUBELIB_CONFIG --include) 

win32:INCLUDEPATH   +=  "C:/Scalasca-Soft/Install/Cube2.0/$$(PREFIX)/install/include/cubegui" \
                        "C:/Scalasca-Soft/Install/Cube2.0/$$(PREFIX)/install/include/cubelib"  \
                        "C:/Scalasca-Soft/Install/Cube2.0/$$(PREFIX)/install/lib/otf2/include/otf2"                      
                        
                        
unix:LIBS      +=  $$system($$CUBEGUI_CONFIG --ldflags) $$system($$CUBEGUI_CONFIG --libs)\
                   $$system($$CUBELIB_CONFIG --ldflags) $$system($$CUBELIB_CONFIG --libs)\
                   $$system($$OTF2_CONFIG --ldflags) $$system($$OTF2_CONFIG --libs)
                   
win32:LIBS     +=   -L"C:/Scalasca-Soft/Install/Cube2.0/$$(PREFIX)/install/lib" -lcube -lcube4gui \
                    -L"C:/Scalasca-Soft/Install/Cube2.0/$$(PREFIX)/install/lib/otf2/lib" -lotf2


                 
TEMPLATE        = lib release
CONFIG += qt plugin release
greaterThan(QT_MAJOR_VERSION, 4): QT += widgets concurrent core



unix:QMAKE_CXXFLAGS_DEBUG    += $$system($$OTF2_CONFIG --cflags) 
win32:QMAKE_CXXFLAGS_DEBUG    += 

QMAKE_CXXFLAGS_RELEASE += $$QMAKE_CXXFLAGS_DEBUG
QMAKE_LFLAGS_DEBUG    +=  
QMAKE_LFLAGS_RELEASE += $$QMAKE_LFLAGS_DEBUG



HEADERS         =   \
                    ../src/gui/BladePlugin.h \
                    ../src/gui/BladePluginWidget.h \
                    ../src/gui/BladeWidget.h \
                    ../src/gui/BladeToolBar.h \
                    ../src/gui/BladeUtils.h \
                    ../src/gui/LoadTraceWidget.h \
                    ../src/gui/LoadFiltersWidget.h \
                    ../src/gui/TraceLoaderThread.h \
                    ../src/gui/SubTraceWidget.h \
                    ../src/gui/SubTraceWidgetHolder.h \
                    ../src/gui/TraceEventFilter.h \
                    ../src/gui/TraceLoadEnterFilter.h \
                    ../src/gui/TraceLoadLeaveFilter.h \
                    ../src/gui/ZoomFilter.h \
                    ../src/gui/ZoomLeaveFilter.h \
                    ../src/gui/ZoomEnterFilter.h \
                    ../src/gui/RoleFilter.h \
                    ../src/gui/RegionPropertiesFilter.h \
                    ../src/gui/CallPathFilter.h \
                    ../src/gui/CallLevelFilter.h \
                    ../src/gui/FlatFilter.h \
                    ../src/gui/SelectionFilter.h \
                    ../src/gui/ResolutionFilter.h \
                    ../src/gui/LocationFilter.h \                    
                    ../src/gui/ColorMap.h \
                    ../src/gui/GraphicsView.h \
                    ../src/gui/MetricGraphicsView.h \
                    ../src/gui/TraceGroupGraphicsView.h \
                    ../src/gui/OverviewGraphicsView.h \
                    ../src/gui/TraceEventRect.h \
                    ../src/gui/OverviewTraceWidget.h \
                    ../src/gui/TraceInfoWidget.h \
                    ../src/gui/TraceControl.h \
                    ../src/gui/TraceEventGroupWidget.h \
                    ../src/gui/MouseLabel.h \
                    ../src/gui/TraceEventGroupAnalyzer.h \
                    ../src/gui/TraceEventGroupGeneralAnalyzer.h \
                    ../src/gui/TraceEventGroupWaitAtBarrierAnalyzer.h \
                    ../src/gui/TraceEventGroupBarrierCompletionAnalyzer.h \
                    ../src/gui/TraceEventGroupWaitAtN2NAnalyzer.h \
                    ../src/gui/TraceEventGroupN2NCompletionAnalyzer.h \
                    ../src/gui/TraceEventGroupLateBroadcastAnalyzer.h \
                    ../src/gui/TraceEventGroupEarlyReduceAnalyzer.h \
                    ../src/gui/TraceEventGroupLateSenderAnalyzer.h \
                    ../src/gui/TraceEventGroupLateReceiverAnalyzer.h \
                    ../src/gui/MetricTraceWidget.h \
                    ../src/tracelib/TraceGlobals.h \
                    ../src/tracelib/Service.h \
                    ../src/tracelib/TraceLoader.h \
                    ../src/tracelib/TraceEvent.h \
                    ../src/tracelib/RequestP2PTraceEvent.h \
                    ../src/tracelib/WaitTraceEvent.h \
                    ../src/tracelib/WaitallTraceEvent.h \
                    ../src/tracelib/P2PTraceEvent.h \
                    ../src/tracelib/AsyncP2PTraceEvent.h \
                    ../src/tracelib/SendP2PTraceEvent.h \
                    ../src/tracelib/RecvP2PTraceEvent.h \
                    ../src/tracelib/ISendP2PTraceEvent.h \
                    ../src/tracelib/IRecvP2PTraceEvent.h \
                    ../src/tracelib/CollectiveTraceEvent.h \
                    ../src/tracelib/BcastTraceEvent.h \
                    ../src/tracelib/ReduceTraceEvent.h \
                    ../src/tracelib/GatherTraceEvent.h \
                    ../src/tracelib/ScanTraceEvent.h \
                    ../src/tracelib/TraceEventPoint.h \
                    ../src/tracelib/TraceEventSection.h \
                    ../src/tracelib/TraceEventStrippedSection.h \
                    ../src/tracelib/Trace.h \
                    ../src/tracelib/RegionClass.h \
                    ../src/tracelib/LocationClass.h \
                    ../src/tracelib/LocationGroupClass.h \
                    ../src/tracelib/SystemTreeNodeClass.h \
                    ../src/tracelib/CallPathClass.h \
                    ../src/tracelib/TraceEventGroup.h \
                    ../src/tracelib/MpiCollectiveGroup.h \
                    ../src/tracelib/MpiP2PGroup.h \
                    ../src/tracelib/OmpParallelGroup.h \
                    ../src/tracelib/TraceEventGroupsCollection.h \
                    ../src/tracelib/MpiCollectiveGroupsCollection.h \
                    ../src/tracelib/MpiP2PGroupsCollection.h \
                    ../src/tracelib/OmpParallelGroupsCollection.h \
                    ../src/tracelib/MetricMemberClass.h \
                    ../src/tracelib/MetricClassClass.h \
                    ../src/tracelib/MetricInstanceClass.h \
                    ../src/tracelib/MetricLine.h \
                    ../src/syntax/BladeParseContext.h \
                    ../src/syntax/Driver.h\
                    ../src/syntax/GeneralEvaluation.h\
                    ../src/syntax/NullaryEvaluation.h\
                    ../src/syntax/UnaryEvaluation.h\
                    ../src/syntax/BinaryEvaluation.h\
                    ../src/syntax/PlusEvaluation.h\
                    ../src/syntax/MinusEvaluation.h\
                    ../src/syntax/MultEvaluation.h\
                    ../src/syntax/DivideEvaluation.h\
                    ../src/syntax/PowerEvaluation.h\
                    ../src/syntax/MaxEvaluation.h\
                    ../src/syntax/MinEvaluation.h\
                    ../src/syntax/DirectMetricEvaluation.h\
                    ../src/syntax/ConstantEvaluation.h\
                    ../src/syntax/DeltaEvaluation.h\
                    ../src/syntax/ForwardEvaluation.h\
                    ../src/syntax/BackwardEvaluation.h\
                    ../src/syntax/EncapsulationEvaluation.h \
                    ../src/syntax/stack.hh \
                    ../src/syntax/position.hh \
                    ../src/syntax/location.hh \
                    ../src/syntax/BladeFlexLexer.h \
                    ../src/syntax/scanner.h \
                    ../src/syntax/parser.hpp
                    
                    
SOURCES         =   \
                    ../src/gui/BladePlugin.cpp\
                    ../src/gui/BladePluginWidget.cpp \
                    ../src/gui/BladeWidget.cpp \
                    ../src/gui/BladeToolBar.cpp \
                    ../src/gui/BladeUtils.cpp \
                    ../src/gui/LoadFiltersWidget.cpp \
                    ../src/gui/LoadTraceWidget.cpp \
                    ../src/gui/TraceLoaderThread.cpp \
                    ../src/gui/SubTraceWidget.cpp\
                    ../src/gui/SubTraceWidgetHolder.cpp \
                    ../src/gui/ZoomFilter.cpp \
                    ../src/gui/ZoomLeaveFilter.cpp \
                    ../src/gui/ZoomEnterFilter.cpp \					
                    ../src/gui/RoleFilter.cpp \
                    ../src/gui/RegionPropertiesFilter.cpp \
                    ../src/gui/CallPathFilter.cpp \
                    ../src/gui/CallLevelFilter.cpp \
                    ../src/gui/FlatFilter.cpp \
                    ../src/gui/SelectionFilter.cpp \
                    ../src/gui/ResolutionFilter.cpp \
                    ../src/gui/LocationFilter.cpp \
                    ../src/gui/TraceLoadEnterFilter.cpp \
                    ../src/gui/TraceLoadLeaveFilter.cpp \					
                    ../src/gui/ColorMap.cpp \
                    ../src/gui/GraphicsView.cpp \
                    ../src/gui/MetricGraphicsView.cpp \
                    ../src/gui/TraceGroupGraphicsView.cpp \
                    ../src/gui/OverviewGraphicsView.cpp \
                    ../src/gui/TraceEventRect.cpp \
                    ../src/gui/OverviewTraceWidget.cpp \
                    ../src/gui/TraceInfoWidget.cpp \
                    ../src/gui/TraceControl.cpp \
                    ../src/gui/TraceEventGroupWidget.cpp \
                    ../src/gui/MouseLabel.cpp \
                    ../src/gui/MetricTraceWidget.cpp \
                    ../src/gui/TraceEventGroupAnalyzer.cpp \
                    ../src/gui/TraceEventGroupGeneralAnalyzer.cpp \
                    ../src/gui/TraceEventGroupWaitAtBarrierAnalyzer.cpp \
                    ../src/gui/TraceEventGroupBarrierCompletionAnalyzer.cpp \
                    ../src/gui/TraceEventGroupWaitAtN2NAnalyzer.cpp \
                    ../src/gui/TraceEventGroupN2NCompletionAnalyzer.cpp \
                    ../src/gui/TraceEventGroupLateBroadcastAnalyzer.cpp \
                    ../src/gui/TraceEventGroupEarlyReduceAnalyzer.cpp \
                    ../src/gui/TraceEventGroupLateSenderAnalyzer.cpp \
                    ../src/gui/TraceEventGroupLateReceiverAnalyzer.cpp \
                    ../src/tracelib/Service.cpp \
                    ../src/tracelib/TraceLoader.cpp \
                    ../src/tracelib/TraceEvent.cpp \
                    ../src/tracelib/SendP2PTraceEvent.cpp \
                    ../src/tracelib/RecvP2PTraceEvent.cpp \
                    ../src/tracelib/ISendP2PTraceEvent.cpp \
                    ../src/tracelib/IRecvP2PTraceEvent.cpp \
                    ../src/tracelib/TraceEventPoint.cpp \
                    ../src/tracelib/TraceEventSection.cpp \
                    ../src/tracelib/TraceEventStrippedSection.cpp \
                    ../src/tracelib/Trace.cpp \
                    ../src/tracelib/CallPathClass.cpp \
                    ../src/tracelib/MetricLine.cpp \
                    ../src/syntax/Driver.cpp\
                    ../src/syntax/GeneralEvaluation.cpp\
                    ../src/syntax/NullaryEvaluation.cpp\
                    ../src/syntax/UnaryEvaluation.cpp\
                    ../src/syntax/BinaryEvaluation.cpp\
                    ../src/syntax/PlusEvaluation.cpp\
                    ../src/syntax/MinusEvaluation.cpp\
                    ../src/syntax/MultEvaluation.cpp\
                    ../src/syntax/DivideEvaluation.cpp\
                    ../src/syntax/PowerEvaluation.cpp\
                    ../src/syntax/MaxEvaluation.cpp\
                    ../src/syntax/MinEvaluation.cpp \
                    ../src/syntax/DirectMetricEvaluation.cpp  \
                    ../src/syntax/ConstantEvaluation.cpp  \
                    ../src/syntax/DeltaEvaluation.cpp  \
                    ../src/syntax/ForwardEvaluation.cpp  \
                    ../src/syntax/BackwardEvaluation.cpp  \
                    ../src/syntax/EncapsulationEvaluation.cpp \
                    ../src/syntax/parser.cpp \
                    ../src/syntax/scanner.cpp
                    
                    
                    
TARGET          = $$qtLibraryTarget(bladeplugin)
RESOURCES       = ../resources/bladeresources.qrc


    flex.name = Flex ${QMAKE_FILE_IN}
    flex.input = FLEXSOURCES
    flex.output = ${QMAKE_FILE_PATH}/${QMAKE_FILE_BASE}.cpp
    flex.commands = flex -o ${QMAKE_FILE_PATH}/${QMAKE_FILE_BASE}.cpp ${QMAKE_FILE_IN}
    flex.CONFIG += target_predeps
    flex.variable_out = GENERATED_SOURCES
    silent:flex.commands = @echo Lex ${QMAKE_FILE_IN} && $$flex.commands
    QMAKE_EXTRA_COMPILERS += flex

    bison.name = Bison ${QMAKE_FILE_IN}
    bison.input = BISONSOURCES
    bison.output = ${QMAKE_FILE_PATH}/${QMAKE_FILE_BASE}.cpp
    bison.commands = bison -d -o ${QMAKE_FILE_PATH}/${QMAKE_FILE_BASE}.cpp ${QMAKE_FILE_IN}
    bison.CONFIG += target_predeps
    bison.variable_out = GENERATED_SOURCES
    silent:bison.commands = @echo Bison ${QMAKE_FILE_IN} && $$bison.commands
    QMAKE_EXTRA_COMPILERS += bison
    bison_header.input = BISONSOURCES
    bison_header.output = ${QMAKE_FILE_PATH}/${QMAKE_FILE_BASE}.hpp
    bison_header.commands = bison  -d -o ${QMAKE_FILE_PATH}/${QMAKE_FILE_BASE}.cpp ${QMAKE_FILE_IN}
    bison_header.CONFIG += target_predeps no_link
    silent:bison_header.commands = @echo Bison ${QMAKE_FILE_IN} && $$bison.commands
    QMAKE_EXTRA_COMPILERS += bison_header

        
    FLEXSOURCES =
    BISONSOURCES = 

    
